﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace PanelBarSample
{
    public class PanelBarZoneContainerViewModel 
    {
        #region Properties

        public string Name { get; set; }

        private bool _isSelected;

        public bool IsSelected
        {
            get
            {
                return this._isSelected;
            }

            set
            {
                if (this._isSelected != value)
                {
                    this._isSelected = value;
                    this.RaisePropertyChanged("IsSelected");
                }
            }
        }

        #region INotifyPropertyChanged values

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
            

        private ZoneExtenderViewModel zoneExtender;

        /// <summary> 
        /// Gets or sets the zone. 
        /// </summary> 
        /// <value> 
        /// The zone. 
        /// </value> 
        public ZoneExtenderViewModel ZoneExtender
        {
            get
            {
                return this.zoneExtender;
            }

            set
            {
                if (this.zoneExtender != value)
                {
                    this.zoneExtender = value;
                    this.RaisePropertyChanged("ZoneExtender");
                }
            }
        }

        private List<ZoneExtenderViewModel> zonesForTab = new List<ZoneExtenderViewModel>();

        /// <summary> 
        /// Gets the zones collection (this.Zone only) for tab Hierarchical binding. 
        /// </summary> 
        public List<ZoneExtenderViewModel> ZonesForTab
        {
            get
            {
                return this.zonesForTab;
            }
        }

        #endregion

        #region Constructors

        public PanelBarZoneContainerViewModel(ZoneExtenderViewModel zone)
        {
            this.ZoneExtender = zone;
            // only add the first time, the radPanelBar needs this hierarchy 
            this.zonesForTab = new List<ZoneExtenderViewModel>();
            this.zonesForTab.Add(this.ZoneExtender);
        }

        #endregion

    } 
}
